SystemOrganization addCategory: #FuelExamples!

Object subclass: #FuelExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelExamples'!

!FuelExamples classSide methodsFor: 'examples' stamp: 'MarianoMartinezPeck 9/15/2011 12:21'!
example1
	| sourceArray loadedArray |
	sourceArray := 
		Array 
			with: 'a string' 
			with: Transcript
			with: [ Transcript show: 'a string' ].
	"Store to the file"
	FLSerializer serialize: sourceArray toFileNamed: 'example.FL'. 
	"Load from the file"
	loadedArray := FLMaterializer materializeFromFileNamed: 'example.FL'. 
	"The arrays are not the same"
	[ sourceArray ~~ loadedArray ] assert.
	"The strings are not the same"
	[ sourceArray first ~~ loadedArray first ] assert.
	[ sourceArray first = loadedArray first ] assert.
	"The global instance Transcript is the same"
	[ sourceArray second == loadedArray second ] assert.
	"Look at Transcript how the loaded block prints a string"
	loadedArray third value.! !

!FuelExamples classSide methodsFor: 'examples' stamp: 'MarianoMartinezPeck 1/10/2012 23:27'!
example2
	"Using progress bars. For this example, you have to load the package 'FuelProgressUpdate' "
	
	FileStream forceNewFileNamed: 'numbers.fl' do: [:aStream |
		FLSerializer newDefault showProgress
			serialize: (1 to: 250000) asArray on: aStream binary ].

	FileStream oldFileNamed: 'numbers.fl' do: [:aStream | 
		(FLMaterializer newDefault showProgress
			materializeFrom: aStream binary) root ].
! !

!FuelExamples classSide methodsFor: 'examples' stamp: 'MarianoMartinezPeck 10/9/2011 20:52'!
example3
	| sourceArray loadedArray serializer stream materializer |
	sourceArray := 
		Array 
			with: 'a string' 
			with: Transcript
			with: [ Transcript show: 'a string' ].
	"Create a file and serialize on it"
	stream := (FileDirectory default forceNewFileNamed: 'example.fuel') binary.
	serializer := FLSerializer newDefault.
	serializer serialize: sourceArray on: stream. 
	stream close. 
	"Load from the file"
	stream := (FileDirectory default oldFileNamed: 'example.fuel') binary.
	materializer := FLMaterializer newDefault.
	loadedArray := materializer materializeFrom: stream. 
! !

!FuelExamples classSide methodsFor: 'examples' stamp: 'MartinDias 10/12/2011 11:58'!
example4
	| byteArray sourceArray loadedArray |
	sourceArray := 
		Array 
			with: 'a string' 
			with: Transcript
			with: [ Transcript show: 'a string' ].
	
	byteArray := FLSerializer serializeToByteArray: sourceArray.
	loadedArray := FLMaterializer materializeFromByteArray: byteArray.
! !
